package com.web.api.config;

import com.web.api.utils.SgUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;

import java.io.IOException;

/**
 * @author 王玉鹏
 * @version 1.0
 * @className GetClientMac
 * @description TODO
 * @date 2020/7/20 16:52
 */
@Slf4j
public class GetClientMac implements Runnable {

    private String ipAddress;

    public GetClientMac(String ipAddress){
        this.ipAddress=ipAddress;
    }
    @Override
    public void run() {
        //linux下获取mac地址
        String  macAddr = "";
        try {
            macAddr = SgUtils.getMac(ipAddress);
        } catch (IOException e) {
           log.error("获取mac地址发生异常:{}",e);
        }
        //windows下获取mac地址
        if(StringUtils.isBlank(macAddr)){
            macAddr = SgUtils.getMacInWindows(ipAddress).trim();
        }
        log.info("客户端mac地址为：{}",macAddr);
    }
}
