package com.web.api.config;

import com.web.api.filter.TokenInterceptor;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.CorsRegistry;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * @author 王玉鹏
 * @version 1.0
 * @className IntercepterConfig
 * @description TODO
 * @date 2019/12/31 9:35
 */
@Configuration
public class IntercepterConfig  implements WebMvcConfigurer {
    @Bean
    public TokenInterceptor myInterceptor() {
        return new TokenInterceptor();
    }

//    @Override
//    public void addInterceptors(InterceptorRegistry registry) {
//        registry.addInterceptor(myInterceptor()).addPathPatterns("/platform/**").addPathPatterns("/answer/**")
//                .excludePathPatterns("/platform/login/**")
//                .excludePathPatterns("/website/**")
//                .excludePathPatterns("/swagger-resources/**", "/webjars/**", "/v2/**", "/swagger-ui.html/**")
//                .excludePathPatterns("/doc.html");
//    }

    @Override
    public void addResourceHandlers(ResourceHandlerRegistry registry) {
        registry.addResourceHandler("swagger-ui.html")
                .addResourceLocations("classpath:/META-INF/resources/");
        registry.addResourceHandler("/webjars/**")
                .addResourceLocations("classpath:/META-INF/resources/webjars/");
    }

    @Override
    public void addCorsMappings(CorsRegistry registry) {
        registry.addMapping("/**") //所有方法
                .allowedOrigins("*") //允许的域名
                .allowCredentials(true)
                .allowedHeaders("*") // 允许请求头
                .allowedMethods("GET", "POST", "DELETE", "PUT", "OPTIONS")//允许方法
                .maxAge(3600); //表明在3600秒内，不需要再发送预检验请求，可以缓存该结果


    }
}
