package com.web.api.dao;

import com.web.api.model.po.AnswerJob;

import java.util.List;

/**
 * AnswerJob的Dao接口
 * 
 * @author 
 *
 */
public interface AnswerJobDao {


	/**
	 * 通过AnswerJob的id获得AnswerJob对象
	 * 
	 * @param id
	 * @return
	 */
	AnswerJob selectAnswerJobById(Integer id);
	
	/**
	 * 获得一个AnswerJob对象,以参数AnswerJob对象中不为空的属性作为条件进行查询,返回符合条件的第一条
	 * 
	 * @param obj
	 * @return
	 */
	AnswerJob selectAnswerJobObjSingle(AnswerJob obj);
	
	/**
	 * 获得一个AnswerJob对象,以参数AnswerJob对象中不为空的属性作为条件进行查询
	 * 
	 * @param obj
	 * @return
	 */
	List<AnswerJob> selectAnswerJobByObj(AnswerJob obj);

	/**
	 * 插入AnswerJob到数据库,包括null值
	 * 
	 * @param value
	 * @return
	 */
	int insertAnswerJob(AnswerJob value);
	
	/**
	 * 插入AnswerJob中属性值不为null的数据到数据库
	 * 
	 * @param value
	 * @return
	 */
	int insertNotNullAnswerJob(AnswerJob value);
	
	/**
	 * 批量插入AnswerJob到数据库,包括null值
	 * 
	 * @param value
	 * @return
	 */
	int insertAnswerJobByBatch(List<AnswerJob> value);
	/**
	 * 通过AnswerJob的id删除AnswerJob
	 * 
	 * @param id
	 * @return
	 */
	int deleteAnswerJobById(Integer id);
	
	/**
	 * 通过AnswerJob的id更新AnswerJob中的数据,包括null值
	 * 
	 * @param enti
	 * @return
	 */
	int updateAnswerJobById(AnswerJob enti);
	
	/**
	 * 通过AnswerJob的id更新AnswerJob中属性不为null的数据
	 * 
	 * @param enti
	 * @return
	 */
	int updateNotNullAnswerJobById(AnswerJob enti);
	

}