package com.web.api.job;

import com.web.api.controller.answer.croe.HttpRequestConfig;
import com.web.api.controller.answer.croe.HttpRequestResult;
import com.web.api.dao.AnswerJobDao;
import com.web.api.dao.ReptileDataDao;
import com.web.api.service.mail.MailServiceImpl;
import com.web.api.utils.Constant;
import com.web.api.utils.HttpClientUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.protocol.HttpContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**
 * @author 王玉鹏
 * @version 1.0
 * @className QiQuTask
 * @description TODO
 * @date 2022/10/14 13:20
 */
@Slf4j
//@Component
public class QiQuTask {

    /**获取user selelct*/
    public final static Pattern DATA_PATTENT = Pattern.compile("<td>(.*)\\s*</td>");

    public final static String BYDD="https://www.qiqutongji.net/tencent";
    public final static String ZZDD="https://www.77tj.org/tencent";

    @Resource
    private ReptileDataDao reptileDataDao;

    /**
     *  每5分钟执行一次
     */
//    @Scheduled(cron = "10 */0 * * * ?")
    public void getData() {
      log.info("开始抓取数据");
        HttpRequestConfig config = HttpRequestConfig.create().url(ZZDD);
        try {
            HttpRequestResult result = HttpClientUtils.get(config);
            String data = result.getResponseText();
            log.info("data:{}",data);
            Matcher dataPattent = DATA_PATTENT.matcher(data);
            String newData = "";
            int count = 0;
            String time ="",value ="",volatility="";
            Map<String,Object> map = new HashMap<>(5);
            while (dataPattent.find() && count <3) {
//                log.info("newData:{}",dataPattent.group(1));
                if (count==0){
                    time = dataPattent.group(1);
                    map.put("time",time);
                }else if(count==1){
                    value = dataPattent.group(1).replace(",","").trim();
                    map.put("onlineCount",Long.parseLong(value));
                }else if(count==2){
                    volatility = dataPattent.group(1);
                    map.put("volatility",volatility);
                }
                count++;
            }
            log.info("最新数据：{}",String.format("时间：%s,在线人数：%s,波动率：%s",time,value,volatility));
//            reptileDataDao.saveReptileData(map);
        } catch (IOException e) {
           log.error("发生异常",e);
        }

    }
}
