package com.web.api.model.dto;

import com.web.api.exception.BusinessException;
import com.web.api.model.po.Content;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.util.StringUtils;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author 王玉鹏
 * @version 1.0
 * @className ContentDto
 * @description TODO
 * @date 2019/12/23 16:38
 */
@Data
public class ContentDto {
    /** 新闻id*/
    private String contentId;
    /** 栏目id*/
    private String contentdirId;
    /** 标题*/
    private String title;
    /** 新闻主体*/
    private String content;
    /** 图片路径*/
    private String imagePath;
    /** 点击量*/
    private int hits;
    /** 排序（0-999），数组越大排序越高*/
    private int sort;
    /** 当前页默认1*/
    private int currentPage = 1;
    /** 页面大小默认5*/
    private int pageSize = 5;

//     else if (StringUtils.isEmpty(this.content)) {
//        throw new BusinessException("内容不能为空");
//    }

    public Content getContentParamers() {
        if (StringUtils.isEmpty(this.title)) {
            throw new BusinessException("title不能为空");
        }else if (StringUtils.isEmpty(this.contentdirId)) {
            throw new BusinessException("栏目id不能为空");
       }else {
            Content content = new Content();
            content.setContentId(this.contentId);
            content.setTitle(this.title);
            content.setContent(this.content);
            content.setImagePath(this.imagePath);
            content.setHits(this.hits);
            content.setSort(this.sort);
            return content;
        }
    }
}
