package com.web.api.model.dto;

import com.web.api.exception.BusinessException;
import com.web.api.model.po.SysUser;
import lombok.Data;
import org.springframework.util.StringUtils;

import javax.persistence.Entity;

/**
 * @author 王玉鹏
 * @version 1.0
 * @className SgUserInfoDto
 * @description TODO
 * @date 2021/12/12 12:18
 */
@Data
@Entity
public class SgUserInfoDto {
    private String userId;
    private String name;
    private Long iphone;
    private String idNumber;
    private String password;
    /*** 用户类型：person(个人)  enter(企业)*/
    private String type;
    private String companyName;
    private String address;
    private String postcode;
    private String organizationCode;
    private String email;
    private String description;

    public SysUser getContentParamers() {
        if (StringUtils.isEmpty(this.name)) {
            throw new BusinessException("姓名不能为空");
        }if (StringUtils.isEmpty(this.iphone)) {
            throw new BusinessException("手机号不能为空");
        } else if (StringUtils.isEmpty(this.password)) {
            throw new BusinessException("密码不能为空");
        } else if (StringUtils.isEmpty(this.type)) {
            throw new BusinessException("会员类型不能为空");
        }else {
            SysUser user = new SysUser();
            user.setUserId(this.userId);
            user.setName(this.name);
            user.setCompanyName(this.companyName);
            user.setPassword(this.password);
            user.setIphone(this.iphone);
            user.setType(this.type);
            user.setAddress(this.address);
            user.setPostcode(this.postcode);
            user.setOrganizationCode(this.organizationCode);
            user.setEmail(this.email);
            user.setDescription(this.description);
            user.setIdNumber(this.idNumber);
            return user;
        }
    }
}
