package com.web.api.utils;

import com.alibaba.fastjson.JSON;
import com.web.api.exception.SgException;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.client.CookieStore;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.cookie.Cookie;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;


/**
 * @author 王玉鹏
 * @version 1.0
 * @className Httputils
 * @description TODO
 * @date 2020/7/8 14:16
 */
@Slf4j
public class CookieUtil {
    /**
     * @author wangyupeng
     * @description 登陆
     * @date  2019/7/5 15:40
     * @param url, map, charset]
     * @return org.apache.http.client.CookieStore
     */
    public static CookieStore getCookies(String url, Map<String, String> map, String charset) throws SgException {
        CloseableHttpClient httpClient = null;
        HttpPost httpPost = null;
        String result = null;
        CookieStore cookieStore = new BasicCookieStore();
        try {
//            HttpHost proxy = new HttpHost("101.43.173.238",8888,"http");
            httpClient = HttpClients.custom().setDefaultCookieStore(cookieStore).build();
            httpPost = new HttpPost(url);
//            httpPost.setHeader(
//                    "User-Agent",
//                    "Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2272.118 Safari/537.36");
//            httpPost.setHeader("User-Agent", "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36");
            httpPost.setHeader("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/104.0.5112.81 Safari/537.36 Edg/104.0.1293.54");
            List<NameValuePair> list = new ArrayList<>();
            Iterator<Map.Entry<String, String>> iterator = map.entrySet().iterator();
            while (iterator.hasNext()) {
                Map.Entry<String, String> elem = iterator.next();
                list.add(new BasicNameValuePair(elem.getKey(), elem.getValue()));
            }
            if (list.size() > 0) {
                UrlEncodedFormEntity entity = new UrlEncodedFormEntity(list, charset);
                httpPost.setEntity(entity);
            }
            CloseableHttpResponse response = httpClient.execute(httpPost);
            HttpEntity entity = response.getEntity();
            if (entity != null){
                System.out.println("网页内容为:"+ EntityUtils.toString(entity,"utf-8"));
            }
            String HyGHnOvkdQZ0y = null;
            String safetycode = null;
            List<Cookie> cookies = cookieStore.getCookies();
            log.info("cookies => {}", JSON.toJSONString(cookies));
            for (int i = 0; i < cookies.size(); i++) {
                if (cookies.get(i).getName().equals("BJ83T0U0lFrKq1")) {
                    HyGHnOvkdQZ0y = cookies.get(i).getValue();
                }
                if (cookies.get(i).getName().equals("safetycode1")) {
                    safetycode = cookies.get(i).getValue();
                }
            }
            if (HyGHnOvkdQZ0y != null) {
                result = "BJ83T0U0lFrKq1="+HyGHnOvkdQZ0y+";safetycode1="+safetycode;
                ContextUtils.setUserStringCookie(result);
                System.out.println("cookie:"+result);
            }
        } catch (Exception ex) {
            log.error("获取cookie异常",ex);
            throw new SgException(ex.getMessage());
        }
        return cookieStore;
    }

//    public static void main(String[] args) throws IOException {
//            //创建httpClient实例
//            CloseableHttpClient httpClient = HttpClients.createDefault();
//            //创建httpGet实例
//            HttpGet httpGet = new HttpGet("https://www.baidu.com/");
//            //设置代理IP，设置连接超时时间 、 设置 请求读取数据的超时时间 、 设置从connect Manager获取Connection超时时间、
//            HttpHost proxy = new HttpHost("61.133.87.228",55443,"http");
////            HttpHost proxy = new HttpHost("47.104.164.205",9988,"http");
//            RequestConfig requestConfig = RequestConfig.custom()
//                    .setProxy(proxy)
//                    .setConnectTimeout(10000)
//                    .setSocketTimeout(10000)
//                    .setConnectionRequestTimeout(3000)
//                    .build();
//            httpGet.setConfig(requestConfig);
//            //设置请求头消息
//            httpGet.setHeader("User-Agent","Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36");
//            CloseableHttpResponse response = httpClient.execute(httpGet);
//
//            System.out.println("获取响应状态: "+ response.getStatusLine().getStatusCode());
//
//            if (response != null){
//                HttpEntity entity = response.getEntity();  //获取返回实体
//                if (entity != null){
//                    System.out.println("网页内容为:"+ EntityUtils.toString(entity,"utf-8"));
//                }
//            }
//            if (response != null){
//                response.close();
//            }
//            if (httpClient != null){
//                httpClient.close();
//            }
//        }
}
